function  inputs = ComputeInputs(points,partitions,region)

global k_gain;

n_robots = size(points,2);
gradients = k_gain * ComputeGradient(points,partitions);
% for i = 1:size(gradients,2)
%     gradients(:,i) = gradients(:,i)/norm(gradients(:,i));
% end

inputs = zeros(size(gradients));

for i = 1:n_robots
    %Vi = ContractPolygon(PartitionToBoundary(partitions(i)),region,points(:,i),0.5);
    Vi = ContractPolygon(ExtractVertices(partitions{i,3}),region,points(:,i),0.5);
    tangents = Tangents(Vi);
    normals = Normals(tangents);
    [active,a,b] = ComputeActiveConstraints(points(:,i),Vi);
    if active == 0 % no active constraints; try forward motion
        inputs(:,i) = ComputeSecureInput(points(:,i),gradients(:,i),Vi);
    elseif active == 1
        if dot(gradients(:,i),normals(:,a)) > 0 % pointing outwards?
            inputs(:,i) = tangents(:,a)*dot(gradients(:,i),tangents(:,a));
            inputs(:,i) = ComputeSecureInput(points(:,i),inputs(:,i),Vi,a);
%             inputs(:,i) = inputs(:,i)/norm(inputs(:,i));
        else
            inputs(:,i) = ComputeSecureInput(points(:,i),gradients(:,i),Vi,a);
        end
    else % active == 2
        if ( dot(gradients(:,i),normals(:,a)) > 0 ) && ...
                ( dot(gradients(:,i),normals(:,a)) > 0 )  %% cornered
            inputs(:,i) = [ 0 ; 0 ]; % useless; just for clarity
        elseif dot(gradients(:,i),normals(:,a)) > 0 % sliding along one edge
            inputs(:,i) = tangents(:,a)*dot(gradients(:,i),tangents(:,a));
%             inputs(:,i) = inputs(:,i)/norm(inputs(:,i));
        elseif dot(gradients(:,i),normals(:,b)) > 0 % sliding along the other edge
            inputs(:,i) = tangents(:,b)*dot(gradients(:,i),tangents(:,b));
%             inputs(:,i) = inputs(:,i)/norm(inputs(:,i));
        else % spurious case; being pulled in
            inputs(:,i) = ComputeSecureInput(points(:,i),gradients(:,i),Vi,a,b);
        end
    end
end
