function f = ComputeSecureInput(p,in,V,a,b)

% Computes an input making sure the robot does not leave its own
% region.
% Hack: if the robot starts from the boudary and has an input pulling
% inside, collision with the edge(s) where it's located should not be
% considered. Hence a,b are optional parameters indicating on which
% edges the point is located

global delta;

if norm(in) < 10^-3
    f = in;
    return
end

if nargin == 3
    a = 0;
    b = 0;
end

if nargin == 4
    b = 0;
end

n_edges = size(V,2)-1;
newp = p + delta*in;
for i = 1:n_edges
    if ( i ~= a ) && ( i ~= b )
        [c,coll] = Myintersect([p(1) p(2) newp(1) newp(2)],...
            [V(1,i) V(2,i) V(1,i+1) V(2,i+1)]);
        if c == 1 % intersection
            f = (coll - p)/delta;
            return;
        end
    end
end

f = in;
