function v = IntegralOnConvexPolygon(f,region)

% f: function to be integrated
% region: vertices of a convex poligonal polygon. Points are on a
% matrx with 2x(n+1) matrix; top row are x coordinates, bootom are y. Last
% entry must be equal to the first one

% Tested: Seems to work fine

    function val = myf(x,y)
        if ( numel(x) == 1 ) && ( numel(y)==1) % scalar case
            in = inpolygon(x,y,region(1,:),region(2,:));
            if  in(1) > 0
                val = f(x,y);
            else
                val = 0;
            end
            return
        end
        if numel(x) > numel(y) % x is a vector, y is a scalar
            y = y * ones(1,numel(x));
        else % y is a vector, y is a scalar
            x = x * ones(1,numel(y));
        end
        val = zeros(1,numel(x));
        in = inpolygon(x,y,region(1,:),region(2,:));
        n = numel(x);
    
        for i = 1:n
            if (in(i) > 0) 
                val(i) = f(x(i),y(i));
            end
        end

%         for i = 1:numel(x)
%             in = inpolygon(x(i),y(i),region(1,:),region(2,:));
%             if  in(1) > 0
%                 val(i) = f(x(i),y(i));
%             else
%                 val(i) = 0;
%             end
%         end
        
    end


xmin = min(region(1,:));
xmax = max(region(1,:));
ymin = min(region(2,:));
ymax = max(region(2,:));

v = dblquad(@myf,xmin,xmax,ymin,ymax,0.001);
end

