function regions = VoronoiPartition(points,bounds,toPlot)

%
% Computes the Voronoi partition induced by points p in the convex region
% r
% p: matrix with 2 rows and n columns (n points in the plane)
% r: matrix with 2 rows and m columns (closed polygon); must be
% a convex region
%

% This requires the multiparametric toolbox
% http://control.ee.ethz.ch/~mpt/daily/builds/
% Tested: works
%

%
% Uses Andrew Kwok's code for bounded Voronoi diagram
% See http://tintoretto.ucsd.edu/andrew/voronoi.html
%
%


if nargin == 2
    toPlot = 0;
end

% p = p';
% pbound = polytope(r');
% Options = struct('plot',toPlot,'pbound',pbound);
% 
% f = mpt_voronoi(p,Options);


regions = voronoi(bounds,points);

if toPlot > 0
    drawRegions(bounds,regions);
end


