close all

global k1;
global k2;

global attractors;
global repellers;

global sigma_attractors;
global sigma_repellers;
global k_gain;

global delta;

% % % First experiment 
% s = RandStream.create('mt19937ar','seed',87);
% RandStream.setDefaultStream(s);
% 
% attractors = [ 1 1  5  3 7 ;
%     1 9 5 2 2];
% 
% repellers = [7 1 6;
%     7 2 3];
% 
% sigma_attractors = 0.5*ones(1,size(attractors,2));
% sigma_repellers = 0.1*ones(1,size(repellers,2));
% 
% k1 = 3;
% k2 = 2;
% 
% points = 7 * rand(2,10);

% 
% % Second experiment 
% s = RandStream.create('mt19937ar','seed',87);
% RandStream.setDefaultStream(s);
% 
% attractors = [ 1 1  5  3 7 ;
%     1 9 5 2 2];
% 
% repellers = [7 1 6;
%     7 2 3];
% 
% sigma_attractors = 0.5*ones(1,size(attractors,2));
% sigma_repellers = 0.1*ones(1,size(repellers,2));
% 
% k1 = 3;
% k2 = 6;
% 
% points = 7 * rand(2,10);


% % Third experiment 
% s = RandStream.create('mt19937ar','seed',11);
% RandStream.setDefaultStream(s);
% 
% attractors = [ 1 1  5  3 7 ;
%     1 9 5 2 2];
% 
% repellers = [3 1 6;
%     7 2 3];
% 
% sigma_attractors = 0.5*ones(1,size(attractors,2));
% sigma_repellers = 0.1*ones(1,size(repellers,2));
% 
% k1 = 3;
% k2 = 8;
%
% points = 7 * rand(2,10);


% Fourth experiment 
% s = RandStream.create('mt19937ar','seed',1805);
% RandStream.setDefaultStream(s);
% 
% attractors = [ 1   5  3 7 1;
%     1  5 2 2 9];
% 
% repellers = [3 1 6 ;
%     7 2 3 ];
% 
% sigma_attractors = 0.5*ones(1,size(attractors,2));
% sigma_repellers = 0.1*ones(1,size(repellers,2));
% 
% k1 = 3;
% k2 = 8;
% 
% points = 8 * rand(2,5);

% Fifth experiment
s = RandStream.create('mt19937ar','seed',2511);
RandStream.setDefaultStream(s);

attractors = [ 1   5  3  1;
    1  5 2  9];

repellers = [3 1 6 7  ;
    7 2 3 1];

sigma_attractors = 0.5*ones(1,size(attractors,2));
sigma_repellers = 0.6*ones(1,size(repellers,2));

k1 = 1;
k2 = 8;

points = [ 8 7;
    0.5 5];


MaxIter = 600;

epsilon = 1e-2;
k_gain = 0.05;
delta = k_gain;

xv = [0 10 10 7 0 ];
yv = [0 0 7  10 10 ];
bounds = [xv ; yv];






X = 0:0.1:10;
Y = 0:0.1:10;

% [GP1,GP2] = meshgrid(X,Y);
%
% for i = 1:size(GP1,1)
%     for j = 1:size(GP1,2)
%         GP1(j,i) = phi1(X(i),Y(j));
%         GP2(j,i) = phi2(X(i),Y(j));
%         in = inpolygon(X(i),Y(j),bounds(1,:),bounds(2,:));
%         if ( in < 1 )
%             GP1(j,i) = 0;
%             GP2(j,i) = 0;
%         end
%     end
% end
%
% figure;
% surf(X,Y,GP1);
% figure
% surf(X,Y,GP2);
%
%
% figure;
% plot(xv,yv);
% axis equal
% grid on
% hold on


% mpt_init('abs_tol',epsilon);

%points = 7 * rand(2,7);

%points = [ 5 1 ]';


nrob = size(points,2);

trajectories = zeros(2,nrob,MaxIter);
trajectories(:,:,1) = points;

distances = zeros(1,MaxIter);

plot(xv,yv);
hold on
axis equal


%points = [ 8 10 ;
%           0 2 ];

h = figure

regions = VoronoiPartition(points,bounds,1);
hold on
plot(attractors(1,:),attractors(2,:),'kv','MarkerSize',15);
plot(repellers(1,:),repellers(2,:),'k^','MarkerSize',15);

nrobots = size(points,2);

g = figure



[val Partitions] = PerformanceFunction(points,bounds);


Val = [ val ];

converged = 0;

i = 1;

[A,b] = vert2con(bounds');

distances(1) = MinDist(points);



while converged ~= 1
    
    % inputs = ComputeInputs(points,Partitions,bounds)
    inputs = ComputeInputsNew(points,A,b,Partitions,bounds);
    
    points = points+delta*inputs
    
    
    % [points,active] = ValidateNewPoints(newpoints,points,bounds);
    [val Partitions] = PerformanceFunction(points,bounds);
    if ( abs(val-Val(:,end))/abs(val)< epsilon/100 ) || ( i >= MaxIter )
        converged = 1;
    end
    
    figure(h);
    VoronoiPartition(points,bounds,1);
    hold on
    plot(attractors(1,:),attractors(2,:),'kv','MarkerSize',15);
    plot(repellers(1,:),repellers(2,:),'k^','MarkerSize',15);
    
    if val <  ( Val(end) - 0.1 * abs(Val(end)) )
        val
        Val(end)
        error('Decreasing objective function');
    end
    Val = [ Val val ];
    i = i + 1
    distances(i) = MinDist(points);
    trajectories(:,:,i) = points;
    figure(g)
    plot(Val)
    pause(0.1);
    
end

distances = distances(1:i);
trajectories = trajectories(:,:,1:i);
figure(h);
hold on
for i =1:nrob
    plot(squeeze(trajectories(1,i,:)),squeeze(trajectories(2,i,:)),'k','LineWidth',1)
end


figure
plot(Val);
grid on
xlabel('Iteration number');
ylabel('Objective function value');